# std library imports
from types import IntType

# archetypes imports
from Products.Archetypes.public import ObjectField, Field
#from Products.Archetypes.public import TypesWidget
from Products.Archetypes.Widget import TypesWidget


class YearWidget(TypesWidget):
    _properties = TypesWidget._properties.copy()
    _properties.update({
        'macro' : "widgets/string",
        'size' : '4',
        'maxlength' : '4',
        })

class YearField(ObjectField):
    """A field that stores years"""
    __implements__ = ObjectField.__implements__

    _properties = Field._properties.copy()
    _properties.update({
        'type' : 'datetime',
        'widget' : YearWidget,
        })

    def set(self, instance, value, **kwargs):
        """
        Ensure it's an int.
        """
        if not value:
            value = None
        elif not isinstance(value, IntType):
            try:
                value = int(value)
            except:
                value = None
        ObjectField.set(self, instance, value, **kwargs)
