from Globals import package_home
from Products.Archetypes.public import process_types, listTypes
from Products.CMFCore import utils
from Products.CMFCore.DirectoryView import registerDirectory

from Products.Biblioz.config import BTOOL_DIR, SKINS_DIR
from Products.Biblioz.config import perms, GLOBALS, PROJECTNAME

registerDirectory(SKINS_DIR, GLOBALS)
registerDirectory(BTOOL_DIR, GLOBALS)

# *Tool stuff
from AmazonTool import AmazonTool
from BibliozTool import BibliozTool
tools = ( AmazonTool, BibliozTool )
import sys
this_module = sys.modules[ __name__ ]
z_tool_bases = utils.initializeBasesPhase1(tools, this_module)


def initialize(context):
    # Biblioz stuff
    ##Import Types here to register them
    import Biblioz
    content_types, constructors, ftis = process_types(
        listTypes(PROJECTNAME),
        PROJECTNAME)
    utils.ContentInit(
        PROJECTNAME + ' Content',
        content_types      = content_types,
        permission         = perms.ADD,
        extra_constructors = constructors,
        fti                = ftis,
        ).initialize(context)

    utils.initializeBasesPhase2(z_tool_bases, context)
    # AmazonTool stuff
    utils.ToolInit( 'Amazon Tool'
                  , tools=tools
                  , product_name='Biblioz'
                  , icon='tool.gif'
                  ).initialize( context )

    # BibliozTool stuff
    utils.ToolInit( 'Biblioz Tool'
                  , tools=tools
                  , product_name='Biblioz'
                  , icon='tool.gif'
                  ).initialize( context )